/**
 * @file DistanceMatrix.h
 * @brief sNX錾
 * @author cherub
 */
#ifndef DISTANCE_MATRIX_CLASS_HEADER_FILE_
#define DISTANCE_MATRIX_CLASS_HEADER_FILE_
#pragma once

#include <vector>
#include "Matrix.h"

/**
 * @class CDistanceMatrix DistanceMatrix.h
 * @brief sNX
 * @author cherub
 */
class CDistanceMatrix : public CMatrix
{
//
// constructor/destructor
public:
	// ftHgRXgN^
	CDistanceMatrix(void);
	// TCYwRXgN^
	CDistanceMatrix(int row, int col);
	// Rs[RXgN^
	CDistanceMatrix(const CDistanceMatrix &src);
	// fXgN^
	virtual ~CDistanceMatrix(void);
	// Zq
	CDistanceMatrix& operator =(const CDistanceMatrix &src);

public:
	/**
	 * @fn bool CDistanceMatrix::IsRange(int r, int c) const
	 * @brief l`FbN
	 * @param r [in] sCfNX
	 * @param c [in] CfNX
	 * @retval true l
	 * @retval false lO
	 */
	bool IsRange(int r, int c) const
		{
			return r >= 0 && r < static_cast<int>(Row()) && c >= 0 && c < static_cast<int>(Col());
		}

	// DPŏoH̎擾 (0, 0)-->(row - 1, col - 1)
	std::vector< std::pair<int, int> > CalcRegistrationCurve() const;
};

#endif //DISTANCE_MATRIX_CLASS_HEADER_FILE_
