/**
 * @file Figure.cpp
 * @brief LN^XPgNX
 * @author cherub
 */
#include "stdafx.h"
#include "Figure.h"


/**
 * @fn CFigure::CFigure()
 * @brief ftHgRXgN^
 */
CFigure::CFigure()
{
	m_pRoot = NULL;
}

/**
 * @fn CFigure::CFigure(CJoint *root)
 * @brief qtRXgN^
 * @param root [in] [gm[hւ̃|C^
 */
CFigure::CFigure(CJoint *root)
{
	m_pRoot = NULL;
	Initialize(root);
}

/**
 * @fn CFigure::CFigure(const CFigure &src)
 * @brief Rs[RXgN^
 * @param src [in] Rs[tBMA
 */
CFigure::CFigure(const CFigure &src)
{
	m_pRoot = new CJoint(src.m_pRoot->GetOffset(), NULL);
	m_pRoot->SetName(src.m_pRoot->GetName());

	std::vector<CJoint*> stacks, stackd;
	stacks.push_back(src.m_pRoot);
	stackd.push_back(m_pRoot);

	while (!stacks.empty())
	{
		CJoint *s = stacks.back(); stacks.pop_back();
		CJoint *d = stackd.back(); stackd.pop_back();

		for (size_t i = 0;i < s->NumChildren();++i)
		{
			CJoint *sj = s->GetChild(i);
			CJoint *dj = new CJoint(sj->GetOffset(), d);
			dj->SetName(sj->GetName());
			d->AddChild(dj);

			stacks.push_back(sj);
			stackd.push_back(dj);
		}
	}

	ListingJoint(m_pRoot);
}

/**
 * @fn CFigure::~CFigure(void)
 * @brief fXgN^
 */
CFigure::~CFigure(void)
{
	m_pRoot->Destroy();
}

/**
 * @fn void CFigure::Initialize(CJoint *root)
 * @brief ֐
 * @param root [in] [gm[hւ̃|C^
 */
void CFigure::Initialize(CJoint *root)
{
	if (m_pRoot != NULL)
		m_pRoot->Destroy();

	m_pRoot = root;
	ListingJoint(root);
}

/**
 * @fn void CFigure::ListingJoint(CJoint *root)
 * @brief XPg؍\̃m[hXg̍쐬
 * @param root [in] [gm[hւ̃|C^
 */
void CFigure::ListingJoint(CJoint *root)
{
	m_vecJoints.push_back(root);
	for (size_t i = 0; i < root->NumChildren(); ++i)
	{
		ListingJoint(root->GetChild(i));
	}
}

/**
 * @fn size_t CFigure::NumJoints() const
 * @brief ֐ߑ̎擾
 * @return ֐ߑ
 */
size_t CFigure::NumJoints() const
{
	return m_vecJoints.size();
}

/**
 * @fn void CFigure::SetRootPosition(const D3DXVECTOR3 &pos)
 * @brief [gʒu̐ݒ
 * @param pos [in] ʒuxNg
 */
void CFigure::SetRootPosition(const D3DXVECTOR3 &pos)
{
	m_pRoot->SetPosition(pos);
}

/**
 * @fn D3DXVECTOR3 CFigure::GetRootPosition() const
 * @brief [gʒu̎擾
 * @return [gʒuxNg
 */
D3DXVECTOR3 CFigure::GetRootPosition() const
{
	return m_pRoot->GetPosition();
}

/**
 * @fn void CFigure::SetRootOrientation(const D3DXQUATERNION &rot)
 * @brief [g̐ݒ
 * @param rot [in] [gNH[^jI
 */
void CFigure::SetRootOrientation(const D3DXQUATERNION &rot)
{
	m_pRoot->SetRotation(rot);
}

/**
 * @fn D3DXQUATERNION CFigure::GetRootOrientation() const
 * @brief [g̎擾
 * @return [gNH[^jI
 */
D3DXQUATERNION CFigure::GetRootOrientation() const
{
	return m_pRoot->GetRotation();
}

/**
 * @fn void CFigure::SetJointRotation(size_t jid, const D3DXQUATERNION &rot)
 * @brief ֐߉]ʂ̐ݒ
 * @param jid [in] ֐߃CfNX
 * @param rot [in] ]NH[^jI
 */
void CFigure::SetJointRotation(size_t jid, const D3DXQUATERNION &rot)
{
	m_vecJoints[jid]->SetRotation(rot);
}

/**
 * @fn D3DXQUATERNION CFigure::GetJointRotation(size_t jid) const
 * @brief ֐߉]ʂ̎擾
 * @param jid [in] ֐߃CfNX
 * @return ]NH[^jI
 */
D3DXQUATERNION CFigure::GetJointRotation(size_t jid) const
{
	return m_vecJoints[jid]->GetRotation();
}

/**
 * @fn CJoint* CFigure::GetRoot()
 * @brief [gm[hւ̃|C^̎擾
 * @return [gm[hւ̃|C^
 */
CJoint* CFigure::GetRoot()
{
	return m_pRoot;
}

/**
 * @fn const CJoint* CFigure::GetRoot() const
 * @brief [gm[hւ̃|C^̎擾(const)
 * @return [gm[hւ̃|C^(const)
 */
const CJoint* CFigure::GetRoot() const
{
	return m_pRoot;
}

/**
 * @fn CJoint* CFigure::GetJoint(size_t jid)
 * @brief ֐߃m[hւ̃|C^̎擾
 * @return ֐߃m[hւ̃|C^
 */
CJoint* CFigure::GetJoint(size_t jid)
{
	return m_vecJoints[jid];
}

/**
 * @fn const CJoint* CFigure::GetJoint(size_t jid) const
 * @brief ֐߃m[hւ̃|C^̎擾(const)
 * @return ֐߃m[hւ̃|C^(const)
 */
const CJoint* CFigure::GetJoint(size_t jid) const
{
	return m_vecJoints[jid];
}

/**
 * @fn D3DXVECTOR3 CFigure::GetWorldPosition(size_t jid) const
 * @brief ֐߃m[h̃[hW̎擾
 * @param jid [in] ֐߃CfNX
 * @return ֐߃m[h̃[hWxNg
 */
D3DXVECTOR3 CFigure::GetWorldPosition(size_t jid) const
{
	D3DXVECTOR3 vTmp(0, 0, 0), vWorldPos(0, 0, 0);
	D3DXMATRIX mTrans;

	mTrans = m_vecJoints[jid]->GetOffsetMatrix();
	D3DXVec3TransformCoord(&vWorldPos, &vTmp, &mTrans);

	for (CJoint *pNode = m_vecJoints[jid]->GetParent();pNode != NULL;pNode = pNode->GetParent())
	{
		mTrans = pNode->GetTransformMatrix();
		vTmp = vWorldPos;
		D3DXVec3TransformCoord(&vWorldPos, &vTmp, &mTrans);
	}
	return vWorldPos;
}

/**
 * @fn D3DXMATRIX CFigure::GetWorldCoordinate(size_t jid) const
 * @brief ֐߃m[h̃[JWn̎擾
 * @param jid [in] ֐߃CfNX
 * @return [hWnɂ֐߃m[h̃[JWn
 */
D3DXMATRIX CFigure::GetWorldCoordinate(size_t jid) const
{
	D3DXMATRIX mWorldCoord = m_vecJoints[jid]->GetOffsetMatrix();
	for (CJoint *pNode = m_vecJoints[jid]->GetParent();pNode != NULL;pNode = pNode->GetParent())
		mWorldCoord *= pNode->GetTransformMatrix();
	return mWorldCoord;
}

/**
 * @fn bool CFigure::IsEffector(size_t jid) const
 * @brief w֐߃m[hGtFN^`FbN
 * @param jid [in] ֐߃m[hCfNX
 * @retval true GtFN^
 * @retval false GtFN^ł͂Ȃ
 */
bool CFigure::IsEffector(size_t jid) const
{
	if (m_vecJoints[jid]->NumChildren() > 0)
		return false;
	return true;
}

/**
 * @fn bool CFigure::SetPose(const CMotionData *mot, size_t frm)
 * @brief [Vf[^̎pɐݒ
 * @param mot [in] [Vf[^
 * @param frm [in] t[ԍ
 * @retval true ݒ萬
 * @retval false ݒ莸s
 */
bool CFigure::SetPose(const CMotionData *mot, size_t frm)
{
	if (NumJoints() != mot->NumJoints() || frm >= mot->NumFrames())
		return false;

	SetRootPosition( mot->GetPosition(frm) );
	for (size_t i = 0, j = 0;j < mot->NumJoints();++i)
	{
		SetJointRotation(i, mot->GetRotation(frm, j++));
	}
	return true;
}

/**
 * @fn int CFigure::FindNode(CJoint *node) const
 * @brief ֐߃m[hւ̃|C^m[hCfNX̌
 * @param node [in] ֐߃m[hւ̃|C^
 * @return ֐߃m[hCfNX
 */
int CFigure::FindNode(CJoint *node) const
{
	int id = -1;
	for (int i = 0;static_cast<size_t>(i) < m_vecJoints.size();++i)
	{
		if (node == m_vecJoints[i])
		{
			id = i;
			break;
		}
	}
	return id;
}

/**
 * @fn int CFigure::FindNode(const char *name) const
 * @brief ֐ߖm[hCfNX̌
 * @param name [in] ֐ߖ
 * @return ֐߃m[hCfNX
 */
int CFigure::FindNode(const char *name) const
{
	int id = -1;
	for (int i = 0;static_cast<size_t>(i) < m_vecJoints.size();++i)
	{
		if (strcmp(name, m_vecJoints[i]->GetName()) == 0)
		{
			id = i;
			break;
		}
	}
	return id;
}

/**
 * @fn std::vector<D3DXVECTOR3> CFigure::GetPointCloud() const
 * @brief ֐߈ʒu_Q̎擾
 * @return ֐߈ʒu_Q
 */
std::vector<D3DXVECTOR3> CFigure::GetPointCloud() const
{
	std::vector<D3DXVECTOR3> pc;
	LPD3DXMATRIXSTACK pMatStack;
	const CJoint *pRoot = GetRoot();
	D3DXVECTOR3 vRootPos = pRoot->GetPosition();

	if (FAILED(D3DXCreateMatrixStack(0, &pMatStack)))
		return pc;

	pMatStack->LoadIdentity();
	pMatStack->MultMatrixLocal(&pRoot->GetTransformMatrix());
	for (size_t j = 0;j < pRoot->NumChildren();j++)
		GetPointCloudSub(pc, pRoot->GetChild(j), pMatStack);
	pMatStack->Release();

	return pc;
}

/**
 * @fn void CFigure::GetPointCloudSub(std::vector<D3DXVECTOR3> &pc, const CJoint *pJoint, LPD3DXMATRIXSTACK &pMatStack) const
 * @brief ֐߈ʒu_Q̎擾Tu֐
 * @param pc [in/out] ֐߈ʒu_Q
 * @param pJoint Ώۊ֐߂ւ̃|C^
 * @param pMatStack vZpsX^bN
 */
void CFigure::GetPointCloudSub(std::vector<D3DXVECTOR3> &pc, const CJoint *pJoint, LPD3DXMATRIXSTACK &pMatStack) const
{
	if (pJoint == NULL)
		return;

	D3DXVECTOR3 v, vzero(0, 0, 0);
	D3DXVec3TransformCoord(&v, &vzero, pMatStack->GetTop());
	pc.push_back(v);

	pMatStack->Push();
		pMatStack->MultMatrixLocal(&pJoint->GetTransformMatrix());
		for (size_t j = 0;j < pJoint->NumChildren();j++)
			GetPointCloudSub(pc, pJoint->GetChild(j), pMatStack);
	pMatStack->Pop();
}

/**
 * @fn std::vector<D3DXVECTOR3> CFigure::GetPointCloudUpperBody() const
 * @brief 㔼g̊֐߈ʒu_Q̎擾í`̂݁DI͖j
 * @return ֐߈ʒu_Q
 */
std::vector<D3DXVECTOR3> CFigure::GetPointCloudUpperBody() const
{
	std::vector<D3DXVECTOR3> pc(4);

	pc[0] = GetWorldPosition( FindNode("vl5") );
	pc[1] = GetWorldPosition( FindNode("vt6") );
	pc[2] = GetWorldPosition( FindNode("r_shoulder") );
	pc[3] = GetWorldPosition( FindNode("l_shoulder") );

	return pc;
}

/**
 * @fn std::vector<D3DXVECTOR3> CFigure::GetPointCloud() const
 * @brief g̊֐߈ʒu_Q̎擾
 * @return ֐߈ʒu_Q
 */
std::vector<D3DXVECTOR3> CFigure::GetPointCloudLowerBody() const
{
	std::vector<D3DXVECTOR3> pc;
	LPD3DXMATRIXSTACK pMatStack;
	const CJoint *pRoot = GetJoint( FindNode("sacroiliac") );

	if (FAILED(D3DXCreateMatrixStack(0, &pMatStack)))
		return pc;

	pMatStack->LoadIdentity();
	pMatStack->MultMatrixLocal(&pRoot->GetTransformMatrix());
	for (size_t j = 0;j < pRoot->NumChildren();j++)
		GetPointCloudSub(pc, pRoot->GetChild(j), pMatStack);
	pMatStack->Release();

	return pc;
}
