/**
 * @file MotionSignal.h
 * @brief NMotionSignalOԂ̐錾
 * @author cherub
 */
#ifndef MOTION_SIGNAL_PROCESSING_NAMESPACE_HEADER_
#define MOTION_SIGNAL_PROCESSING_NAMESPACE_HEADER_
#pragma once

#include <vector>
#include "MotionData.h"
#include "Vector.h"
#include "Figure.h"

/**
 * @namespace NMotionSignal MotionSignal.h
 * @brief [Vf[^ɑ΂M֐Q̖O
 * @author cherub
 */
namespace NMotionSignal
{
	// ̉]NH[^jI̕
	D3DXQUATERNION InterpolateRotations(const std::vector<D3DXQUATERNION> &rots, const std::vector<float> &kernel);
	// tB^O
	bool Filter(CMotionData &dest, const std::vector<float> &kernel);
	// 2̓̕
	bool Interpolate(CMotionData &dest, const CMotionData &src1, const CMotionData &src2, float ratio);
	// ̓̕
	bool Interpolate(CMotionData &dest, const std::vector<CMotionData*> &srcs, const std::vector<float> &kernel);
	// 2̓̓
	bool Synchronize(CMotionData &dest, CVector& iitw, const CMotionData &src, const CMotionData &base, const CFigure &fig);
	// QIԕϊ
	bool IncrementalTimewarp(CMotionData &dest, const CMotionData &src, const CVector &itw);
	// 2̓̃[VufBO
	bool Blend(CMotionData &dest, const CMotionData &src1, const CMotionData &src2, float ratio, const CFigure &fig);
	// ̓̃[VufBO
	bool Blend(CMotionData &dest, const std::vector<CMotionData*> &srcs, const std::vector<float> &kernel, const CFigure &fig);
};

#endif //MOTION_SIGNAL_PROCESSING_NAMESPACE_HEADER_
