/**
 * @file TimewarpMatrix.h
 * @brief sNX錾
 * @author cherub
 */
#ifndef TIMEWARP_MATRIX_CLASS_HEADER_FILE_
#define TIMEWARP_MATRIX_CLASS_HEADER_FILE_
#pragma once

#include <vector>
#include <utility>

#include "Matrix.h"
#include "Vector.h"
#include "MotionData.h"

/**
 * @class CTimewarpMatrix
 * @brief TimewarpϊsNX
 * @author cherub
 */
class CTimewarpMatrix : public CMatrix
{
public:
	// ftHgRXgN^
	CTimewarpMatrix(void);
	// DPŏoH񂩂̃RXgN^
	CTimewarpMatrix(const std::vector<std::pair<int, int>> &vecPath);
	// Rs[RXgN^
	CTimewarpMatrix(const CTimewarpMatrix &src);
	// fXgN^
	virtual ~CTimewarpMatrix(void);

	// Zq
	CTimewarpMatrix& operator =(const CTimewarpMatrix &src);

public:
	// DPŏoH񂩂̎ԕϊs񏉊
	bool Initialize(const std::vector<std::pair<int, int>> &vecPath);

	// Ԍoߏ̎ԕϊ
	CVector Transform(const CVector &vSequence) const;
	// [Vf[^̎ԕϊ
	CMotionData Transform(const CMotionData &src) const;

//
// ̃\bhANZX֎~ɂ
private:
	CMatrix Inverse3x3(void) const;
	CMatrix InverseLUD() const;
	CMatrix InverseSVD(double dThreshold) const;
	double Determinant(void) const;
};

#endif //TIMEWARP_MATRIX_CLASS_HEADER_FILE_
